"""LCM type definitions
This file automatically generated by lcm.
DO NOT MODIFY BY HAND!!!!
"""

try:
    import cStringIO.StringIO as BytesIO
except ImportError:
    from io import BytesIO
import struct

class latitude_t(object):
    __slots__ = ["value", "ns_indicator"]

    def __init__(self):
        self.value = 0.0
        self.ns_indicator = ""

    def encode(self):
        buf = BytesIO()
        buf.write(latitude_t._get_packed_fingerprint())
        self._encode_one(buf)
        return buf.getvalue()

    def _encode_one(self, buf):
        buf.write(struct.pack(">d", self.value))
        __ns_indicator_encoded = self.ns_indicator.encode('utf-8')
        buf.write(struct.pack('>I', len(__ns_indicator_encoded)+1))
        buf.write(__ns_indicator_encoded)
        buf.write(b"\0")

    def decode(data):
        if hasattr(data, 'read'):
            buf = data
        else:
            buf = BytesIO(data)
        if buf.read(8) != latitude_t._get_packed_fingerprint():
            raise ValueError("Decode error")
        return latitude_t._decode_one(buf)
    decode = staticmethod(decode)

    def _decode_one(buf):
        self = latitude_t()
        self.value = struct.unpack(">d", buf.read(8))[0]
        __ns_indicator_len = struct.unpack('>I', buf.read(4))[0]
        self.ns_indicator = buf.read(__ns_indicator_len)[:-1].decode('utf-8', 'replace')
        return self
    _decode_one = staticmethod(_decode_one)

    _hash = None
    def _get_hash_recursive(parents):
        if latitude_t in parents: return 0
        tmphash = (0xed0d3534434a05b2) & 0xffffffffffffffff
        tmphash  = (((tmphash<<1)&0xffffffffffffffff)  + (tmphash>>63)) & 0xffffffffffffffff
        return tmphash
    _get_hash_recursive = staticmethod(_get_hash_recursive)
    _packed_fingerprint = None

    def _get_packed_fingerprint():
        if latitude_t._packed_fingerprint is None:
            latitude_t._packed_fingerprint = struct.pack(">Q", latitude_t._get_hash_recursive([]))
        return latitude_t._packed_fingerprint
    _get_packed_fingerprint = staticmethod(_get_packed_fingerprint)

